# Perform optinal tests
%bcond_without perl_meta_enables_optional_test

Name:           perl-meta
Version:        0.013
Release:        2%{?dist}
Summary:        Meta-programming API
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/dist/meta
Source0:        https://cpan.metacpan.org/authors/id/P/PE/PEVANS/meta-%{version}.tar.gz
BuildRequires:  coreutils
BuildRequires:  findutils
BuildRequires:  perl-devel
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(:VERSION) >= 5.14
BuildRequires:  perl(ExtUtils::CBuilder)
BuildRequires:  perl(Module::Build)
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
# Run-time:
BuildRequires:  perl(Carp)
BuildRequires:  perl(XSLoader)
# Tests:
BuildRequires:  perl(experimental)
BuildRequires:  perl(feature)
BuildRequires:  perl(Sub::Util)
BuildRequires:  perl(Test2::Require::Module)
BuildRequires:  perl(Test2::V0)
%if %{with perl_meta_enables_optional_test}
# Optional tests:
BuildRequires:  perl(Test::Pod) >= 1.00
%endif

%description
This package provides an API for Perl meta programming; that is, allowing code
to inspect or manipulate parts of its own program structure. Parts of the perl
interpreter itself can be accessed by means of "meta"-objects provided by this
package. Methods on these objects allow inspection of details, as well as
creating new items or removing existing ones.

%package tests
Summary:        Tests for %{name}
BuildArch:      noarch
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       perl-Test-Harness

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%autosetup -p1 -n meta-%{version}
%if !%{with perl_meta_enables_optional_test}
rm t/99pod.t
perl -i -ne 'print $_ unless m{t/99pod\.t}' MANIFEST
%endif
chmod +x t/*.t

%build
perl Build.PL --installdirs=vendor --optimize='%{optflags}'
./Build

%install
./Build install --destdir=%{buildroot} --create_packlist=0
find %{buildroot} -type f -name '*.bs' -size 0 -delete
%{_fixperms} %{buildroot}/*
# Install tests
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
%if %{with perl_meta_enables_optional_test}
rm %{buildroot}%{_libexecdir}/%{name}/t/99pod.t
%endif
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
./Build test

%files
%license LICENSE
%doc Changes README
%{perl_vendorarch}/auto/meta
%{perl_vendorarch}/meta.pm
%{_mandir}/man3/meta.*

%files tests
%{_libexecdir}/%{name}

%changelog
* Fri Apr 25 2025 Jitka Plesnikova <jplesnik@redhat.com> - 0.013-2
- Perl 5.42 rebuild

* Thu Apr 24 2025 Petr Pisar <ppisar@redhat.com> - 0.013-1
- 0.013 bump

* Sat Jan 18 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0.012-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Oct 15 2024 Petr Pisar <ppisar@redhat.com> - 0.012-1
- 0.012 bump

* Tue Oct 08 2024 Petr Pisar <ppisar@redhat.com> - 0.011-1
- 0.011 bump

* Thu Oct 03 2024 Petr Pisar <ppisar@redhat.com> - 0.010-1
- 0.010 bump

* Mon Sep 16 2024 Petr Pisar <ppisar@redhat.com> - 0.009-1
- 0.009 bump

* Thu Sep 12 2024 Petr Pisar <ppisar@redhat.com> - 0.008-2
- Fix a possible undefined behavior in S_get_metaglob_slot (CPAN RT#151024)

* Thu Sep 12 2024 Petr Pisar <ppisar@redhat.com> - 0.008-1
- 0.008 bump

* Wed Sep 11 2024 Petr Pisar <ppisar@redhat.com> - 0.007-1
- 0.007 bump

* Tue Sep 10 2024 Petr Pisar <ppisar@redhat.com> - 0.006-1
- 0.006 bump

* Fri Jul 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.004-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Mon Jun 10 2024 Jitka Plesnikova <jplesnik@redhat.com> - 0.004-2
- Perl 5.40 rebuild

* Tue Jan 30 2024 Petr Pisar <ppisar@redhat.com> - 0.004-1
- 0.004 bump

* Thu Jan 04 2024 Petr Pisar <ppisar@redhat.com> 0.003-1
- Specfile autogenerated by cpanspec 1.78.
